<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'Envelope' => '\\StructType\\Envelope',
            'Header' => '\\StructType\\Header',
            'Body' => '\\StructType\\Body',
            'Fault' => '\\StructType\\Fault',
            'detail' => '\\StructType\\Detail',
            'intestazionePPT' => '\\StructType\\IntestazionePPT',
            'intestazioneCarrelloPPT' => '\\StructType\\IntestazioneCarrelloPPT',
            'risposta' => '\\StructType\\Risposta',
            'faultBean' => '\\StructType\\FaultBean',
            'nodoChiediStatoRPT' => '\\StructType\\NodoChiediStatoRPT',
            'nodoChiediStatoRPTRisposta' => '\\StructType\\NodoChiediStatoRPTRisposta',
            'esitoChiediStatoRPT' => '\\StructType\\EsitoChiediStatoRPT',
            'tipoStoricoRPT' => '\\StructType\\TipoStoricoRPT',
            'tipoStoricoVersamento' => '\\StructType\\TipoStoricoVersamento',
            'nodoChiediCopiaRT' => '\\StructType\\NodoChiediCopiaRT',
            'nodoChiediCopiaRTRisposta' => '\\StructType\\NodoChiediCopiaRTRisposta',
            'nodoInviaRichiestaStorno' => '\\StructType\\NodoInviaRichiestaStorno',
            'nodoInviaRichiestaStornoRisposta' => '\\StructType\\NodoInviaRichiestaStornoRisposta',
            'nodoInviaRPT' => '\\StructType\\NodoInviaRPT',
            'nodoInviaRPTRisposta' => '\\StructType\\NodoInviaRPTRisposta',
            'nodoInviaCarrelloRPT' => '\\StructType\\NodoInviaCarrelloRPT',
            'tipoListaRPT' => '\\StructType\\TipoListaRPT',
            'tipoElementoListaRPT' => '\\StructType\\TipoElementoListaRPT',
            'nodoInviaCarrelloRPTRisposta' => '\\StructType\\NodoInviaCarrelloRPTRisposta',
            'listaErroriRPT' => '\\StructType\\ListaErroriRPT',
            'nodoChiediListaPendentiRPT' => '\\StructType\\NodoChiediListaPendentiRPT',
            'nodoChiediListaPendentiRPTRisposta' => '\\StructType\\NodoChiediListaPendentiRPTRisposta',
            'tipoListaRPTPendenti' => '\\StructType\\TipoListaRPTPendenti',
            'tipoRPTPendente' => '\\StructType\\TipoRPTPendente',
            'nodoChiediInformativaPSP' => '\\StructType\\NodoChiediInformativaPSP',
            'nodoChiediInformativaPSPRisposta' => '\\StructType\\NodoChiediInformativaPSPRisposta',
            'nodoChiediElencoQuadraturePA' => '\\StructType\\NodoChiediElencoQuadraturePA',
            'nodoChiediElencoQuadraturePARisposta' => '\\StructType\\NodoChiediElencoQuadraturePARisposta',
            'tipoListaQuadrature' => '\\StructType\\TipoListaQuadrature',
            'tipoIdQuadratura' => '\\StructType\\TipoIdQuadratura',
            'nodoChiediQuadraturaPA' => '\\StructType\\NodoChiediQuadraturaPA',
            'nodoChiediQuadraturaPARisposta' => '\\StructType\\NodoChiediQuadraturaPARisposta',
            'nodoChiediElencoFlussiRendicontazione' => '\\StructType\\NodoChiediElencoFlussiRendicontazione',
            'nodoChiediElencoFlussiRendicontazioneRisposta' => '\\StructType\\NodoChiediElencoFlussiRendicontazioneRisposta',
            'tipoElencoFlussiRendicontazione' => '\\StructType\\TipoElencoFlussiRendicontazione',
            'tipoIdRendicontazione' => '\\StructType\\TipoIdRendicontazione',
            'nodoChiediFlussoRendicontazione' => '\\StructType\\NodoChiediFlussoRendicontazione',
            'nodoChiediFlussoRendicontazioneRisposta' => '\\StructType\\NodoChiediFlussoRendicontazioneRisposta',
            'nodoChiediSceltaWISP' => '\\StructType\\NodoChiediSceltaWISP',
            'nodoChiediSceltaWISPRisposta' => '\\StructType\\NodoChiediSceltaWISPRisposta',
        );
    }
}
