<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for intestazionePPT StructType
 * @subpackage Structs
 */
class IntestazionePPT extends AbstractStructBase
{
    /**
     * The identificativoIntermediarioPA
     * Meta informations extracted from the WSDL
     * - maxLength: 35
     * - minLength: 1
     * @var string
     */
    public $identificativoIntermediarioPA;
    /**
     * The identificativoStazioneIntermediarioPA
     * Meta informations extracted from the WSDL
     * - maxLength: 35
     * - minLength: 1
     * @var string
     */
    public $identificativoStazioneIntermediarioPA;
    /**
     * The identificativoDominio
     * Meta informations extracted from the WSDL
     * - maxLength: 35
     * - minLength: 1
     * @var string
     */
    public $identificativoDominio;
    /**
     * The identificativoUnivocoVersamento
     * Meta informations extracted from the WSDL
     * - maxLength: 35
     * - minLength: 1
     * @var string
     */
    public $identificativoUnivocoVersamento;
    /**
     * The codiceContestoPagamento
     * Meta informations extracted from the WSDL
     * - maxLength: 35
     * - minLength: 1
     * @var string
     */
    public $codiceContestoPagamento;
    /**
     * The actor
     * Meta informations extracted from the WSDL
     * - ref: soapenv:actor
     * - use: optional
     * @var string
     */
    public $actor;
    /**
     * The mustUnderstand
     * Meta informations extracted from the WSDL
     * - ref: soapenv:mustUnderstand
     * - use: optional
     * @var string
     */
    public $mustUnderstand;
    /**
     * Constructor method for intestazionePPT
     * @uses IntestazionePPT::setIdentificativoIntermediarioPA()
     * @uses IntestazionePPT::setIdentificativoStazioneIntermediarioPA()
     * @uses IntestazionePPT::setIdentificativoDominio()
     * @uses IntestazionePPT::setIdentificativoUnivocoVersamento()
     * @uses IntestazionePPT::setCodiceContestoPagamento()
     * @uses IntestazionePPT::setActor()
     * @uses IntestazionePPT::setMustUnderstand()
     * @param string $identificativoIntermediarioPA
     * @param string $identificativoStazioneIntermediarioPA
     * @param string $identificativoDominio
     * @param string $identificativoUnivocoVersamento
     * @param string $codiceContestoPagamento
     * @param string $actor
     * @param string $mustUnderstand
     */
    public function __construct($identificativoIntermediarioPA = null, $identificativoStazioneIntermediarioPA = null, $identificativoDominio = null, $identificativoUnivocoVersamento = null, $codiceContestoPagamento = null, $actor = null, $mustUnderstand = null)
    {
        $this
            ->setIdentificativoIntermediarioPA($identificativoIntermediarioPA)
            ->setIdentificativoStazioneIntermediarioPA($identificativoStazioneIntermediarioPA)
            ->setIdentificativoDominio($identificativoDominio)
            ->setIdentificativoUnivocoVersamento($identificativoUnivocoVersamento)
            ->setCodiceContestoPagamento($codiceContestoPagamento)
            ->setActor($actor)
            ->setMustUnderstand($mustUnderstand);
    }
    /**
     * Get identificativoIntermediarioPA value
     * @return string|null
     */
    public function getIdentificativoIntermediarioPA()
    {
        return $this->identificativoIntermediarioPA;
    }
    /**
     * Set identificativoIntermediarioPA value
     * @param string $identificativoIntermediarioPA
     * @return \StructType\IntestazionePPT
     */
    public function setIdentificativoIntermediarioPA($identificativoIntermediarioPA = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($identificativoIntermediarioPA) && strlen($identificativoIntermediarioPA) > 35) || (is_array($identificativoIntermediarioPA) && count($identificativoIntermediarioPA) > 35)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 35 element(s) or a scalar of 35 character(s) at most, "%d" length given', is_scalar($identificativoIntermediarioPA) ? strlen($identificativoIntermediarioPA) : count($identificativoIntermediarioPA)), __LINE__);
        }
        // validation for constraint: minLength
        if ((is_scalar($identificativoIntermediarioPA) && strlen($identificativoIntermediarioPA) < 1) || (is_array($identificativoIntermediarioPA) && count($identificativoIntermediarioPA) < 1)) {
            throw new \InvalidArgumentException('Invalid length, please provide an array with 1 element(s) or a scalar of 1 character(s) at least', __LINE__);
        }
        // validation for constraint: string
        if (!is_null($identificativoIntermediarioPA) && !is_string($identificativoIntermediarioPA)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($identificativoIntermediarioPA)), __LINE__);
        }
        $this->identificativoIntermediarioPA = $identificativoIntermediarioPA;
        return $this;
    }
    /**
     * Get identificativoStazioneIntermediarioPA value
     * @return string|null
     */
    public function getIdentificativoStazioneIntermediarioPA()
    {
        return $this->identificativoStazioneIntermediarioPA;
    }
    /**
     * Set identificativoStazioneIntermediarioPA value
     * @param string $identificativoStazioneIntermediarioPA
     * @return \StructType\IntestazionePPT
     */
    public function setIdentificativoStazioneIntermediarioPA($identificativoStazioneIntermediarioPA = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($identificativoStazioneIntermediarioPA) && strlen($identificativoStazioneIntermediarioPA) > 35) || (is_array($identificativoStazioneIntermediarioPA) && count($identificativoStazioneIntermediarioPA) > 35)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 35 element(s) or a scalar of 35 character(s) at most, "%d" length given', is_scalar($identificativoStazioneIntermediarioPA) ? strlen($identificativoStazioneIntermediarioPA) : count($identificativoStazioneIntermediarioPA)), __LINE__);
        }
        // validation for constraint: minLength
        if ((is_scalar($identificativoStazioneIntermediarioPA) && strlen($identificativoStazioneIntermediarioPA) < 1) || (is_array($identificativoStazioneIntermediarioPA) && count($identificativoStazioneIntermediarioPA) < 1)) {
            throw new \InvalidArgumentException('Invalid length, please provide an array with 1 element(s) or a scalar of 1 character(s) at least', __LINE__);
        }
        // validation for constraint: string
        if (!is_null($identificativoStazioneIntermediarioPA) && !is_string($identificativoStazioneIntermediarioPA)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($identificativoStazioneIntermediarioPA)), __LINE__);
        }
        $this->identificativoStazioneIntermediarioPA = $identificativoStazioneIntermediarioPA;
        return $this;
    }
    /**
     * Get identificativoDominio value
     * @return string|null
     */
    public function getIdentificativoDominio()
    {
        return $this->identificativoDominio;
    }
    /**
     * Set identificativoDominio value
     * @param string $identificativoDominio
     * @return \StructType\IntestazionePPT
     */
    public function setIdentificativoDominio($identificativoDominio = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($identificativoDominio) && strlen($identificativoDominio) > 35) || (is_array($identificativoDominio) && count($identificativoDominio) > 35)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 35 element(s) or a scalar of 35 character(s) at most, "%d" length given', is_scalar($identificativoDominio) ? strlen($identificativoDominio) : count($identificativoDominio)), __LINE__);
        }
        // validation for constraint: minLength
        if ((is_scalar($identificativoDominio) && strlen($identificativoDominio) < 1) || (is_array($identificativoDominio) && count($identificativoDominio) < 1)) {
            throw new \InvalidArgumentException('Invalid length, please provide an array with 1 element(s) or a scalar of 1 character(s) at least', __LINE__);
        }
        // validation for constraint: string
        if (!is_null($identificativoDominio) && !is_string($identificativoDominio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($identificativoDominio)), __LINE__);
        }
        $this->identificativoDominio = $identificativoDominio;
        return $this;
    }
    /**
     * Get identificativoUnivocoVersamento value
     * @return string|null
     */
    public function getIdentificativoUnivocoVersamento()
    {
        return $this->identificativoUnivocoVersamento;
    }
    /**
     * Set identificativoUnivocoVersamento value
     * @param string $identificativoUnivocoVersamento
     * @return \StructType\IntestazionePPT
     */
    public function setIdentificativoUnivocoVersamento($identificativoUnivocoVersamento = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($identificativoUnivocoVersamento) && strlen($identificativoUnivocoVersamento) > 35) || (is_array($identificativoUnivocoVersamento) && count($identificativoUnivocoVersamento) > 35)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 35 element(s) or a scalar of 35 character(s) at most, "%d" length given', is_scalar($identificativoUnivocoVersamento) ? strlen($identificativoUnivocoVersamento) : count($identificativoUnivocoVersamento)), __LINE__);
        }
        // validation for constraint: minLength
        if ((is_scalar($identificativoUnivocoVersamento) && strlen($identificativoUnivocoVersamento) < 1) || (is_array($identificativoUnivocoVersamento) && count($identificativoUnivocoVersamento) < 1)) {
            throw new \InvalidArgumentException('Invalid length, please provide an array with 1 element(s) or a scalar of 1 character(s) at least', __LINE__);
        }
        // validation for constraint: string
        if (!is_null($identificativoUnivocoVersamento) && !is_string($identificativoUnivocoVersamento)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($identificativoUnivocoVersamento)), __LINE__);
        }
        $this->identificativoUnivocoVersamento = $identificativoUnivocoVersamento;
        return $this;
    }
    /**
     * Get codiceContestoPagamento value
     * @return string|null
     */
    public function getCodiceContestoPagamento()
    {
        return $this->codiceContestoPagamento;
    }
    /**
     * Set codiceContestoPagamento value
     * @param string $codiceContestoPagamento
     * @return \StructType\IntestazionePPT
     */
    public function setCodiceContestoPagamento($codiceContestoPagamento = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($codiceContestoPagamento) && strlen($codiceContestoPagamento) > 35) || (is_array($codiceContestoPagamento) && count($codiceContestoPagamento) > 35)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 35 element(s) or a scalar of 35 character(s) at most, "%d" length given', is_scalar($codiceContestoPagamento) ? strlen($codiceContestoPagamento) : count($codiceContestoPagamento)), __LINE__);
        }
        // validation for constraint: minLength
        if ((is_scalar($codiceContestoPagamento) && strlen($codiceContestoPagamento) < 1) || (is_array($codiceContestoPagamento) && count($codiceContestoPagamento) < 1)) {
            throw new \InvalidArgumentException('Invalid length, please provide an array with 1 element(s) or a scalar of 1 character(s) at least', __LINE__);
        }
        // validation for constraint: string
        if (!is_null($codiceContestoPagamento) && !is_string($codiceContestoPagamento)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($codiceContestoPagamento)), __LINE__);
        }
        $this->codiceContestoPagamento = $codiceContestoPagamento;
        return $this;
    }
    /**
     * Get actor value
     * @return string|null
     */
    public function getActor()
    {
        return $this->actor;
    }
    /**
     * Set actor value
     * @param string $actor
     * @return \StructType\IntestazionePPT
     */
    public function setActor($actor = null)
    {
        // validation for constraint: string
        if (!is_null($actor) && !is_string($actor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($actor)), __LINE__);
        }
        $this->actor = $actor;
        return $this;
    }
    /**
     * Get mustUnderstand value
     * @return string|null
     */
    public function getMustUnderstand()
    {
        return $this->mustUnderstand;
    }
    /**
     * Set mustUnderstand value
     * @param string $mustUnderstand
     * @return \StructType\IntestazionePPT
     */
    public function setMustUnderstand($mustUnderstand = null)
    {
        // validation for constraint: string
        if (!is_null($mustUnderstand) && !is_string($mustUnderstand)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mustUnderstand)), __LINE__);
        }
        $this->mustUnderstand = $mustUnderstand;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\IntestazionePPT
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
