<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for listaErroriRPT StructType
 * @subpackage Structs
 */
class ListaErroriRPT extends AbstractStructBase
{
    /**
     * The fault
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\FaultBean[]
     */
    public $fault;
    /**
     * Constructor method for listaErroriRPT
     * @uses ListaErroriRPT::setFault()
     * @param \StructType\FaultBean[] $fault
     */
    public function __construct(array $fault = array())
    {
        $this
            ->setFault($fault);
    }
    /**
     * Get fault value
     * @return \StructType\FaultBean[]|null
     */
    public function getFault()
    {
        return $this->fault;
    }
    /**
     * Set fault value
     * @throws \InvalidArgumentException
     * @param \StructType\FaultBean[] $fault
     * @return \StructType\ListaErroriRPT
     */
    public function setFault(array $fault = array())
    {
        foreach ($fault as $listaErroriRPTFaultItem) {
            // validation for constraint: itemType
            if (!$listaErroriRPTFaultItem instanceof \StructType\FaultBean) {
                throw new \InvalidArgumentException(sprintf('The fault property can only contain items of \StructType\FaultBean, "%s" given', is_object($listaErroriRPTFaultItem) ? get_class($listaErroriRPTFaultItem) : gettype($listaErroriRPTFaultItem)), __LINE__);
            }
        }
        $this->fault = $fault;
        return $this;
    }
    /**
     * Add item to fault value
     * @throws \InvalidArgumentException
     * @param \StructType\FaultBean $item
     * @return \StructType\ListaErroriRPT
     */
    public function addToFault(\StructType\FaultBean $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FaultBean) {
            throw new \InvalidArgumentException(sprintf('The fault property can only contain items of \StructType\FaultBean, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->fault[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ListaErroriRPT
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
