<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for nodoInviaRPTRisposta StructType
 * Meta informations extracted from the WSDL
 * - type: ppt:nodoInviaRPTRisposta
 * @subpackage Structs
 */
class NodoInviaRPTRisposta extends Risposta
{
    /**
     * The esito
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $esito;
    /**
     * The redirect
     * Meta informations extracted from the WSDL
     * - default: 0
     * - minOccurs: 0
     * @var int
     */
    public $redirect;
    /**
     * The url
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $url;
    /**
     * Constructor method for nodoInviaRPTRisposta
     * @uses NodoInviaRPTRisposta::setEsito()
     * @uses NodoInviaRPTRisposta::setRedirect()
     * @uses NodoInviaRPTRisposta::setUrl()
     * @param string $esito
     * @param int $redirect
     * @param string $url
     */
    public function __construct($esito = null, $redirect = 0, $url = null)
    {
        $this
            ->setEsito($esito)
            ->setRedirect($redirect)
            ->setUrl($url);
    }
    /**
     * Get esito value
     * @return string|null
     */
    public function getEsito()
    {
        return $this->esito;
    }
    /**
     * Set esito value
     * @param string $esito
     * @return \StructType\NodoInviaRPTRisposta
     */
    public function setEsito($esito = null)
    {
        // validation for constraint: string
        if (!is_null($esito) && !is_string($esito)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($esito)), __LINE__);
        }
        $this->esito = $esito;
        return $this;
    }
    /**
     * Get redirect value
     * @return int|null
     */
    public function getRedirect()
    {
        return $this->redirect;
    }
    /**
     * Set redirect value
     * @param int $redirect
     * @return \StructType\NodoInviaRPTRisposta
     */
    public function setRedirect($redirect = 0)
    {
        // validation for constraint: int
        if (!is_null($redirect) && !is_numeric($redirect)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($redirect)), __LINE__);
        }
        $this->redirect = $redirect;
        return $this;
    }
    /**
     * Get url value
     * @return string|null
     */
    public function getUrl()
    {
        return $this->url;
    }
    /**
     * Set url value
     * @param string $url
     * @return \StructType\NodoInviaRPTRisposta
     */
    public function setUrl($url = null)
    {
        // validation for constraint: string
        if (!is_null($url) && !is_string($url)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($url)), __LINE__);
        }
        $this->url = $url;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\NodoInviaRPTRisposta
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
