<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for tipoStoricoRPT StructType
 * @subpackage Structs
 */
class TipoStoricoRPT extends AbstractStructBase
{
    /**
     * The data
     * @var string
     */
    public $data;
    /**
     * The stato
     * @var string
     */
    public $stato;
    /**
     * The descrizione
     * @var string
     */
    public $descrizione;
    /**
     * Constructor method for tipoStoricoRPT
     * @uses TipoStoricoRPT::setData()
     * @uses TipoStoricoRPT::setStato()
     * @uses TipoStoricoRPT::setDescrizione()
     * @param string $data
     * @param string $stato
     * @param string $descrizione
     */
    public function __construct($data = null, $stato = null, $descrizione = null)
    {
        $this
            ->setData($data)
            ->setStato($stato)
            ->setDescrizione($descrizione);
    }
    /**
     * Get data value
     * @return string|null
     */
    public function getData()
    {
        return $this->data;
    }
    /**
     * Set data value
     * @param string $data
     * @return \StructType\TipoStoricoRPT
     */
    public function setData($data = null)
    {
        // validation for constraint: string
        if (!is_null($data) && !is_string($data)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($data)), __LINE__);
        }
        $this->data = $data;
        return $this;
    }
    /**
     * Get stato value
     * @return string|null
     */
    public function getStato()
    {
        return $this->stato;
    }
    /**
     * Set stato value
     * @param string $stato
     * @return \StructType\TipoStoricoRPT
     */
    public function setStato($stato = null)
    {
        // validation for constraint: string
        if (!is_null($stato) && !is_string($stato)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($stato)), __LINE__);
        }
        $this->stato = $stato;
        return $this;
    }
    /**
     * Get descrizione value
     * @return string|null
     */
    public function getDescrizione()
    {
        return $this->descrizione;
    }
    /**
     * Set descrizione value
     * @param string $descrizione
     * @return \StructType\TipoStoricoRPT
     */
    public function setDescrizione($descrizione = null)
    {
        // validation for constraint: string
        if (!is_null($descrizione) && !is_string($descrizione)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($descrizione)), __LINE__);
        }
        $this->descrizione = $descrizione;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TipoStoricoRPT
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
